<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        #{dataTableStateHolder.setDescendingOn('id')}
        <h2>#{messages['net.ihe.gazelle.atna.ListCertificateRequests']}</h2>

        <h:form id="globalForm">

            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{certificatesListBean.filter.urlParameters}"/>
            <script>
                updateUrl("globalForm:filterUrlParameters");
                jq162("#globalForm\\:filterUrlParameters").bind('change',
                        function () {
                            updateUrl("globalForm:filterUrlParameters");
                        });
            </script>
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>

            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">

                <div class="form-horizontal">
                    <div class="row">
                        <div class="col-md-6">

                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.atna.Requester']}"/>
                                <ui:param name="filterId" value="requester"/>
                                <ui:param name="filter" value="#{certificatesListBean.filter}"/>
                                <ui:param name="filterForm" value="globalForm"/>
                            </ui:include>

                            <ui:decorate template="/layout/form/_form_checkbox_horizontal_4-8.xhtml">
                                <h:selectBooleanCheckbox id="checkBoxProcess"
                                                         value="#{certificatesListBean.displayOnlyNotProcessed}">
                                    <a4j:ajax event="change" render="globalForm"/>
                                </h:selectBooleanCheckbox>
                                #{messages['net.ihe.gazelle.atna.ShowOnlyUnsignedRequests']}
                            </ui:decorate>

                        </div>
                        <div class="col-md-6">

                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.proxy.Type']}"/>
                                <ui:param name="filterId" value="type"/>
                                <ui:param name="filter" value="#{certificatesListBean.filter}"/>
                                <ui:param name="filterForm" value="globalForm"/>
                            </ui:include>

                        </div>
                    </div>
                </div>

                <ui:define name="filter_buttons">
                    <a4j:commandLink title="#{messages['net.ihe.gazelle.atna.ResetCriteria']}"
                                     actionListener="#{certificatesListBean.resetCertificateRequestFilter()}"
                                     render="globalForm">
                        <span class="fa fa-times-circle"></span>
                    </a4j:commandLink>
                </ui:define>

            </ui:decorate>

            <rich:dataTable id="requestTable" value="#{certificatesListBean.dataModelRequests}" var="certificateRequest"
                            rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="requestDS">

                <g:column sortBy="#{'id'}" sortOrder="#{dataTableStateHolder.sortOrders['id']}">
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.RequestId']}"/>
                    </ui:define>
                    <h:outputText value="#{certificateRequest.id}"/>
                    <s:span styleClass="fa fa-globe" title="#{messages['net.ihe.gazelle.atna.ThisIsACASAutoLoginCertificateRequest']}"
                            rendered="#{certificatesListBean.isCasAutoLoginRequest(certificateRequest)}"/>
                    <s:span styleClass="fa fa-upload" title="#{messages['net.ihe.gazelle.atna.ThisIsAnUploadedCSR']}"
                            rendered="#{certificatesListBean.isUploadedCSRRequest(certificateRequest)}"/>
                </g:column>

                <g:column sortBy="#{'subject'}" filterBy="#{'subject'}"
                          sortOrder="#{dataTableStateHolder.sortOrders['subject']}"
                          styleClass="gzl-break-long-word">
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.Subject']}"/>
                    </ui:define>
                    <h:outputText value="#{certificateRequest.subject}"/>
                </g:column>

                <g:column sortBy="#{'certificateExtension'}"
                          sortOrder="#{dataTableStateHolder.sortOrders['certificateExtension']}">
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.Type']}"/>
                    </ui:define>
                    <h:outputText value="#{certificateRequest.certificateExtension.getFriendlyName()}"/>
                </g:column>

                <g:column sortBy="#{'certificateAuthority.subject'}"
                          sortOrder="#{dataTableStateHolder.sortOrders['certificateAuthority.subject']}"
                          filterBy="#{'certificateAuthority.subject'}">
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.CASubject']}"/>
                    </ui:define>
                    <h:commandLink value="#{certificateRequest.certificateAuthority.subject}"
                                   rendered="#{certificateRequest.certificateAuthority != null}"
                                   action="#{certificateBean.redirectToCert(certificateRequest.certificateAuthority.id)}"
                                   target="_blank"/>
                    <h:outputText value="#{messages['net.ihe.gazelle.atna.None']}"
                                  rendered="#{certificateRequest.certificateAuthority == null}"/>
                </g:column>

                <g:column sortBy="#{'requesterUsername'}"
                          sortOrder="#{dataTableStateHolder.sortOrders['requesterUsername']}">
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.Requester']}"/>
                    </ui:define>
                    <h:outputText value="#{certificatesListBean.getUserName(certificateRequest.requesterUsernameWithKey)}"/>
                </g:column>

                <g:column sortBy="#{'requestDate'}"
                          sortOrder="#{dataTableStateHolder.sortOrders['requestDate']}">
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.Date_2']}"/>
                    </ui:define>
                    <g:date value="#{certificateRequest.requestDate}"/>
                </g:column>

                <rich:column>
                    <f:facet name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.Signed']}"/>
                    </f:facet>
                    <s:span styleClass="fa fa-check text-success"
                            rendered="#{not empty certificateRequest.certificate}"
                            title="#{messages['net.ihe.gazelle.atna.RequestSigned']}"></s:span>
                    <s:span styleClass="fa fa-times text-danger"
                            rendered="#{certificateRequest.certificate == null}"
                            title="#{messages['net.ihe.gazelle.atna.RequestNotYetSigned']}"></s:span>
                </rich:column>

                <rich:column styleClass="text-right">
                    <f:facet name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.Action']}"/>
                    </f:facet>
                    <div class="gzl-never-wrap">
                        <h:outputLink value="#{certificatesListBean.getRequestViewLink(certificateRequest.id)}"
                                      title="#{messages['net.ihe.gazelle.atna.ViewRequest']}">
                            <span class="fa fa-search"></span>
                        </h:outputLink>
                        <a4j:commandLink action="#{certificateBean.redirectToCert(certificateRequest.certificate.id)}"
                                         title="#{messages['net.ihe.gazelle.atna.ViewCertificate']}"
                                         rendered="#{not empty certificateRequest.certificate}" execute="@this"
                                         styleClass="action text-normal">
                            <s:span styleClass="fa fa-certificate"></s:span>
                        </a4j:commandLink>
                        <a4j:commandLink action="#{requestList.validate(certificateRequest.id)}"
                                         render="messages,requestTable"
                                         title="#{messages['net.ihe.gazelle.atna.SignRequest']}"
                                         rendered="#{s:hasRole('admin_role') and certificateRequest.certificate == null}"
                                         styleClass="action text-success">
                            <s:span styleClass="fa fa-check"></s:span>
                        </a4j:commandLink>
                        <a4j:commandLink action="#{requestList.setRequestToRegenerate(certificateRequest.id)}"
                                         oncomplete="jq162('#regenerateModal').modal('show');"
                                         title="#{messages['net.ihe.gazelle.atna.RegenerateCertificate']}"
                                         rendered="#{s:hasRole('admin_role') and not empty certificateRequest.certificate}"
                                         styleClass="action text-warning">
                            <s:span styleClass="fa fa-refresh"></s:span>
                        </a4j:commandLink>
                        <a4j:commandLink action="#{requestList.setRequestToDelete(certificateRequest.id)}"
                                         oncomplete="jq162('#deleteModal').modal('show');"
                                         title="#{messages['net.ihe.gazelle.atna.DeleteRequest']}"
                                         rendered="#{s:hasRole('admin_role') and certificateRequest.certificate == null}"
                                         styleClass="action text-danger">
                            <s:span styleClass="fa fa-trash-o"></s:span>
                        </a4j:commandLink>
                    </div>
                </rich:column>

                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="requestDS"/>
                        <ui:param name="dataTableId" value="requestTable"/>
                    </ui:include>
                </f:facet>

            </rich:dataTable>

        </h:form>

        <h:form id="regenerateForm" rendered="#{s:hasRole('admin_role')}">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="regenerateModal"/>
                <ui:define name="popup_title"><span class="fa fa-exclamation-triangle"></span>#{messages['net.ihe.gazelle.questionnaire.Warning']}
                </ui:define>
                <p>#{messages['net.ihe.gazelle.atna.YouAreAboutToGenerateANewCertificateSigningReque']}</p>

                <p>#{messages['net.ihe.gazelle.atna.WeStronglyRecommandTo']} <strong>#{messages['net.ihe.gazelle.atna.NotPerformThisActionOnACertificateAuthority']}</strong>
                    #{messages['net.ihe.gazelle.atna.ThatHasAlreadyDeliveredCertificatesExceptIfYouKn']}</p>
                <ui:define name="popup_footer">
                    <button type="button" class="gzl-btn" data-dismiss="modal">
                        #{messages['net.ihe.gazelle.atna.Cancel']}
                    </button>
                    <a4j:commandButton action="#{requestList.regenerateSelectedRequest()}"
                                       oncomplete="jq162('#regenerateModal').modal('hide')"
                                       value="#{messages['net.ihe.gazelle.atna.RegenerateCertificate']}"
                                       render="gazelle-messages,requestTable"
                                       styleClass="gzl-btn-orange">
                    </a4j:commandButton>
                </ui:define>
            </ui:decorate>
        </h:form>

        <h:form id="deleteForm" rendered="#{s:hasRole('admin_role')}">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="deleteModal"/>
                <ui:define name="popup_title"><span class="fa fa-exclamation-triangle"></span>#{messages['net.ihe.gazelle.questionnaire.Warning']}
                </ui:define>
                <p>#{messages['net.ihe.gazelle.atna.YouAreAboutToDeleteTheRequestThisCanNotBeUndone']}</p>
                <ui:define name="popup_footer">
                    <button type="button" class="gzl-btn" data-dismiss="modal">
                        #{messages['net.ihe.gazelle.atna.Cancel']}
                    </button>
                    <a4j:commandButton actionListener="#{requestList.deleteSelectedRequest()}"
                                       oncomplete="jq162('#deleteModal').modal('hide')"
                                       value="#{messages['net.ihe.gazelle.atna.Delete']}"
                                       render="gazelle-messages,requestTable"
                                       styleClass="gzl-btn-red">
                    </a4j:commandButton>
                </ui:define>
            </ui:decorate>
        </h:form>

    </ui:define>
</ui:composition>
